//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LBUTTON_H_
#define LBUTTON_H_

#include "LWidget.h"
#include "sysdep/LButton.h"
#include "LWindow.h"

class LButton:public LWidget{
// If this platform needs some 'friend' declarations, the preprocessor
// will put them here
#ifdef PLATFORM_DEPENDANT_LBUTTON_FRIENDS
  PLATFORM_DEPENDANT_LBUTTON_FRIENDS
#endif
protected:
  //System-dependant field
  SysDepButtonData SysDep;         // Definition is in ./sysdep/LButton.h

  //System-dependant methods
  virtual void Apply();            // Commits changes and resets modification
                                   // flags; the definition is in
                                   // ./sysdep/LButton.cc, because
                                   // this method is platform-dependant

  virtual void SystemDependantInit();
                                   // Called in the constructor, defined in
                                   // ./sysdep/LButton.cc

  virtual void SystemDependantDone();
                                   // Called in the destructor, defined in
                                   // ./sysdep/LButton.cc
public:
  //Constructor and Destructor
  LButton(LContainer&);
  ~LButton();
};

#endif//#ifndef LBUTTON_H_




