//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LMENU_H_X11_
#define LMENU_H_X11_

extern "C"{
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>
}

#include "../../LTypes.h"
#include "../../../Lhash.h"

// Declaration as static function
static void UniversalLMenuCallBack(Widget,XtPointer,XtPointer);

// Declaration as friend function, to be included in the class header.
#define PLATFORM_DEPENDANT_LMENU_FRIENDS \
  friend void UniversalLMenuCallBack(Widget,XtPointer,XtPointer);

// Define the width of hash tables. Menu items may be many, so a quite big
// number is better to avoid collisions and so improve performance
#define HASHSIZE  64

struct SysDepMenuData{
  Widget menuwidget;         // The Athena SimpleMenu widget
  Widget menubuttonwidget;   // The Athena MenuButton widget
  char menuname[11];         // The name used by Athena to bind the correct
                             // menu shell to its menu button: this is _not_
                             // the menu caption.

  // Hash tables used to bind callbacks and widget numbers to menu entries
  Lhash<LCallBack,Lstring,HASHSIZE> callbacks;
  Lhash<Widget,Lstring,HASHSIZE>    widgets;

  // Constructor used to initialize hash tables
  SysDepMenuData();
};

#endif //#ifndef LMENU_H_X11_





