//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LSCROLLBAR_H_X11_
#define LSCROLLBAR_H_X11_

extern "C"{
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/X.h>
}

struct SysDepScrollBarData{
  int length;     // scrollbar lenght in pixels, excluding buttons, and
  int thumbsize;  // leght of the scroll thumb; I need them in callbacks,
                  // and storing the values here allows me not to access
                  // the LAttributeTable, slightly improving the performance.

  Widget widget;
};
// Declaration of the friend function as static: I cannot say it's static
// in the friend declaration, so I make the compiler know it now.
static void UniversalLScrollBarCallBackChange(Widget,XtPointer,XtPointer);
static void UniversalLScrollBarCallBackScroll(Widget,XtPointer,XtPointer);

// Friend functions declaration, to be included in class header
#define PLATFORM_DEPENDANT_LSCROLLBAR_FRIENDS \
  friend void UniversalLScrollBarCallBackChange(Widget,XtPointer,XtPointer);\
  friend void UniversalLScrollBarCallBackScroll(Widget,XtPointer,XtPointer);

#endif //#ifdef LSCROLLBAR_H_X11_





