//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#include "../../LTextLabel.h"
#include "../../LAttributes.h"
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>

void LTextLabel::Apply(){
  if(TestAndSet(LAW))
    XtVaSetValues(SysDep.widget,XtNwidth,GetInt(LAW),
                                0); // Apply width changes
  if(TestAndSet(LAH))
    XtVaSetValues(SysDep.widget,XtNheight,GetInt(LAH),
                                0); // Apply height changes
  if(TestAndSet(LAX))
    XtVaSetValues(SysDep.widget,XtNhorizDistance,GetInt(LAX),
                                0); // Apply x position changes
  if(TestAndSet(LAY))
    XtVaSetValues(SysDep.widget,XtNvertDistance,GetInt(LAY),
                                0); // Apply y position changes
  if(TestAndSet(LAText))
    XtVaSetValues(SysDep.widget,XtNlabel,GetString(LAText).
                                                     ToCharStar(),
                                0); // Apply text changes
}

void LTextLabel::SystemDependantInit(){
  SysDep.widget=XtVaCreateManagedWidget("LTextLabel",
                  labelWidgetClass,parent->SysDep.area,
                  XtNborderWidth, 0,     // Athena labels have borderWidth=1
                                         //by default
                  XtNbottom,        XtChainTop,
                  XtNtop,           XtChainTop,
                  XtNleft,          XtChainLeft,
                  XtNright,         XtChainLeft,
                  XtNjustify,       XtJustifyLeft,
                  XtNhorizDistance, 1,
                  XtNvertDistance,  1,
                  XtNresizable,     TRUE,
                  XtNvisual,        GlobalSysDep.visual,
                  XtNcolormap,      GlobalSysDep.colormap,
                  0);
  Apply();
}

void LTextLabel::SystemDependantDone(){
}




