//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LWINDOW_H_X11_
#define LWINDOW_H_X11_

extern "C"{
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
}

struct SysDepWindowData{
  Widget stupid;    // Dirty hack: to avoid the SysDep.area Athena form
                    // widget resizes when a child changes state, put a
                    // little invisible rectangle in the lower right
                    // position, so that the minimal dimension the form
                    // wants is the one _we_ want.
                    // It's a 1x1 pixels Athena textlabel widget.

  int distance;     // used to store the SysDep.area defaultDistance
                    // resource, useful to place stupid.

  Widget shell;     // The Xt shell, parent of widget.

  Widget widget;    // The Xt 'skeleton' widget, parent of window, statusbar
                    // and menubar. It's an Athena form.

  Widget menubar;   // The Xt status bar widget, child of widget. It's an
                    // Athena box.

  Widget statusbar; // The Xt status bar widget, child of widget. It's an
                    // Athena label.

  bool IsShown;     // Flags internally used to store the current status of
  bool IsModal;     // the widget.
};

#endif //#ifdef LWINDOW_H_X11_



